function [betterCombs,scores,scores_bsl,ci_scores]=chooseBestCombinationEachDimension(...
    sel_ord,stat_ord,stat_bsl,dim_feat,ngroups)    
%
% Author: Carlos Platero
% Date: 2019/07/21
% 
% General inquiries: carlos.platero@upm.es
%


betterCombs=zeros(ngroups*length(dim_feat),max(dim_feat));
label_dim=zeros(ngroups*length(dim_feat),1);
freq_dim=zeros(ngroups*length(dim_feat),1);
scores=zeros(ngroups*length(dim_feat),7);
scores_bsl=zeros(ngroups*length(dim_feat),7);
ci_scores=zeros(ngroups*length(dim_feat),12,2);


bestCombs=zeros(length(dim_feat),max(dim_feat));
bestScores=zeros(length(dim_feat),7);
bestBslScores=zeros(length(dim_feat),7);


for i=1:size(sel_ord,3)
    feat_dim=sel_ord(:,:,i);
    stats=stat_ord(:,:,i);
    stats_bsl=stat_bsl(:,:,i);
    
    mask_no_null=stats(:,1)>0;
    feat_dim=feat_dim(mask_no_null,:);
    stats=stats(mask_no_null,:);
    stats_bsl=stats_bsl(mask_no_null,:);
    
    feat_dim=feat_dim(:,1:dim_feat(i));
    feat_dim=sort(feat_dim,2);
    feat_sort = sort_frecuency(feat_dim,ngroups);
    betterCombs(((i-1)*ngroups)+1:i*ngroups,1:dim_feat(i))=feat_sort;
    label_dim(((i-1)*ngroups)+1:i*ngroups)=dim_feat(i);
    for j=1:ngroups
        index=find(sum(feat_dim==feat_sort(j,:),2)==dim_feat(i));
        freq_dim(((i-1)*ngroups)+j)=length(index);
        if(length(index)>1)
            stats_feat=mean(stats(index,:),'omitnan');
            ci_long=CI_matrix(stats(index,:));
            stats_feat_bsl=mean(stats_bsl(index,:),'omitnan');
            ci_bsl=CI_matrix(stats_bsl(index,:));
        else
            stats_feat=stats(index,:);
            stats_feat_bsl=stats_bsl(index,:);
            ci_long=zeros(1,12);
            ci_bsl =zeros(1,12);
        end
        scores(((i-1)*ngroups)+j,:)=[stats_feat,length(index)];
        scores_bsl(((i-1)*ngroups)+j,:)=[stats_feat_bsl,length(index)];
        ci_scores(((i-1)*ngroups)+j,:,1)=ci_long;
        ci_scores(((i-1)*ngroups)+j,:,2)=ci_bsl;
        
        if(stats_feat(1)>bestScores(i,1)) %Sensitivity
            bestScores(i,:)=[stats_feat,length(index)];
            bestBslScores(i,:)=[stats_feat_bsl,length(index)];
            bestCombs(i,1:dim_feat(i))=feat_sort(j,:);
        end
        
    end
end

    
    


end

function ci_scores=CI_matrix(scores)
numScores=size(scores,2);
ci_scores=zeros(1,numScores*2);
for i=1:numScores
    ci_scores(1,[(i-1)*2+1,i*2])=confidenceIntervals(scores(:,i));
end

end

function CI = confidenceIntervals(x)
SEM = std(x,'omitnan')/sqrt(length(x));               % Standard Error
ts = tinv([0.025  0.975],length(x)-1);      % T-Score
CI = mean(x,'omitnan') + ts*SEM;                      % Confidence Intervals
end
