function [final_selection]=choosebest_ngroups(stat_feat,initial_selection,ngroups,init_ngr,dim_feat)
%This function evaluates accuracy taking in count steps of dimension groups
%
% Author: Carlos Platero
% Date: 2019/07/21
% 
% General inquiries: carlos.platero@upm.es
%

final_selection=zeros(ngroups*length(dim_feat),max(dim_feat));

for i=1:length(dim_feat)
    %each iteration takes one dimension of features groups. Example, in the
    %first iteration we take the 10 tries for the first dimension and
    %reduce them to 3 in the final selection
    
    tmp_selection = initial_selection((i-1)*init_ngr+1:i*init_ngr,:);
    tmp_results = stat_feat((i-1)*init_ngr+1:i*init_ngr,:);
    
    [~,idx] = choosebest(tmp_results);
    
    final_selection(  (i-1)*ngroups+1:i*ngroups  , :)=...
        tmp_selection(idx(1:ngroups),:);  
end
end