function acc = classLME(model_class,err_test,diagn_two_GT_test)
%
% Author: Carlos Platero
% Date: 2019/07/21
% 
% General inquiries: carlos.platero@upm.es
%
mask_nan=isnan(err_test(:,1));
if(sum(mask_nan)>0)
    err_test(mask_nan,:)=[];
    diagn_two_GT_test(mask_nan)=[];
end

numPatients=size(err_test,1);
score=zeros(numPatients,2);
for i=1:numPatients
    [~,~,~,score(i,:)]=predict(model_class,err_test(i,:));
end

two_labels=unique(diagn_two_GT_test);
onlyOneClass=false;
if(length(two_labels)~=2)
    if(length(two_labels)==1 && (two_labels==10 || two_labels==20))
        two_labels=[10;20];
        onlyOneClass=true;
    else
        error('labels are not expected');
    end
end
[~,class]=max(score,[],2);
if(sum(class==2)>0)
    class(class==2)=two_labels(2);
end
if(sum(class==1)>0)
    class(class==1)=two_labels(1);
end


% Quality
[C_all,~] = confusionmat(diagn_two_GT_test,class);
if(length(C_all(:))==4)

    TN=C_all(1,1);
    FN=C_all(2,1);
    FP=C_all(1,2);
    TP=C_all(2,2);
    sensitivy=TP/(TP+FN);
    specificity=TN/(TN+FP);
    PPV = TP/(TP+FP);
    NPV= TN/(TN+FN);
    ACC= (TN+TP)/(TN+TP+FN+FP);
    if(onlyOneClass==false)
        [~,~,~,auc]=perfcurve(diagn_two_GT_test,score(:,2),two_labels(2));
    else
        auc=ACC;
    end
    acc=[sensitivy,specificity,PPV,NPV,ACC,auc];
else
    acc=zeros(1,6);

end
end