function table_sort=featureSelectionADNI_ROI(features,group,ni,dim_feat,ngroups)
% This function is charged of selecting the best characteristics and
% returns the frequency of each feature. This script must be executed
% before groupFeatureSelection because here the input for that is being
% decided.
%
% Author: Carlos Platero
% Date: 2019/07/21
% 
% General inquiries: carlos.platero@upm.es
%
%% Selection
numFeat=size(features,2);

%n_boot depending on dim_feat to ensure a certain frequency
n_boot = 100 + dim_feat*10;

freq_feat=zeros(n_boot,numFeat);
parfor i=1:n_boot
    
    [mask_scan_train,~,~,~]=splitSamples(ni,.75,-1);
    
    if(length(unique(group(mask_scan_train)))<2)
        mask_scan_train=addSujectOtherGroup_cross(group,...
            unique(group(mask_scan_train)),mask_scan_train);
    end   
    

    %% Feature selection
    featSorted = featureSelection_mRMR(features(mask_scan_train,:),...
        group(mask_scan_train));
    freq_feat(i,:)=featSorted;
    
         
end

if dim_feat==0
        table=freq_feat(:,1:2);
        [a,b]=hist(x,unique(x));
        tmp_out=[b' sum((a),2)];
        stmp=sortrows(tmp_out,2);
        table_Sort=(stmp(ngroups,1));

else
    %otherwise we sort the frequency of the groups that appear in the k
    %first places.
    table=freq_feat(:,1:dim_feat);
    table_sort = sort(table,2);
    table_sort = sort_frecuency(table_sort,ngroups);
end


end


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% Auxiliar
function featSorted = featureSelection_mRMR(features,group)
group=double(group);
numFeat=size(features,2);
numSamples=size(features,1);

%Normalization
features=(features-repmat(mean(features),numSamples,1))./repmat(std(features),numSamples,1);

%mRMR
featSorted=mrmr_miq_d(features, group, numFeat); 

end

