function [error_train,error_test,diagn_two_GT_train,diagn_two_GT_test]=...
    getLMEmulti_visits(X,Y,mask_scan_train,mask_scan_test,ni_two_train,...
    ni_two_test,bsl,varVisit)
%
% Author: Carlos Platero
% Date: 2019/07/21
% 
% General inquiries: carlos.platero@upm.es
%

numFeatures=size(Y,2);
%% Class
error_train=zeros(length(ni_two_train),numFeatures);

if(bsl)
    error_test=zeros(length(ni_two_test),numFeatures,2);
else
    error_test=zeros(length(ni_two_test),numFeatures,1);
end

code_bsl=1;

for i=1:numFeatures       
%% Only baseline
if(varVisit==code_bsl)
    [e_train,e_test] = get_LME_err_train_new(X(mask_scan_train,:),...
        Y(mask_scan_train,i),ni_two_train,X(mask_scan_test,:),...
        Y(mask_scan_test,i),ni_two_test,bsl);
    
%% Visits
else
    [e_train,e_test]= get_LME_err_train_new_visits(X(mask_scan_train,:),...
        Y(mask_scan_train,i),ni_two_train,X(mask_scan_test,:),...
        Y(mask_scan_test,i),ni_two_test,bsl,varVisit);
end
%% Common
    error_test(:,i,:)=e_test;
    error_train(:,i)=e_train;

end

group_two_train=X(mask_scan_train,3);

group_two_test=X(mask_scan_test,3);
group_two_test(group_two_test==0)=10;
group_two_test(group_two_test==1)=20;

%% Only baseline
if(varVisit==code_bsl)
    [diagn_two_GT_train,diagn_two_GT_test]=getTrainTestLabels(group_two_train,...
        group_two_test,ni_two_train,ni_two_test);

%% Visits
else
    [mask_test_visits,ni_test_visits,mask_subjs] = selectedVisits(X(mask_scan_test,end),ni_two_test,varVisit);
    
    error_test=error_test(mask_subjs,:,:);
    group_two_test=group_two_test(mask_test_visits);
    [diagn_two_GT_train,diagn_two_GT_test]=getTrainTestLabels(group_two_train,...
        group_two_test,ni_two_train,ni_test_visits);
end

end


function [diagn_two_GT_train,diagn_two_GT_test]=getTrainTestLabels...
    (group_two_train,group_two_test,ni_two_train,ni_two_test)
% Train
numPatients=length(ni_two_train);
diagn_two_GT_train=zeros(numPatients,1);
begin_index=0;
for i=1:numPatients
    numImgs=ni_two_train(i);
    begin_index=begin_index+1;
    end_index=begin_index+numImgs-1;
    diagn_two_GT_train(i)=group_two_train(begin_index);
    begin_index=end_index;
end


% Test
numPatients=length(ni_two_test);
diagn_two_GT_test=zeros(numPatients,1);
begin_index=0;
for i=1:numPatients
    numImgs=ni_two_test(i);
    begin_index=begin_index+1;
    end_index=begin_index+numImgs-1;
    diagn_two_GT_test(i)=group_two_test(begin_index);
    begin_index=end_index;
end

end




